import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.table.*;
import java.io.*;

public class Form extends JFrame {
    
    public Form() {
        initComponents();
    }
    
    private JToolBar jToolBar1; // pasek narzedzi
    private JButton jButton1; // zapisz
    private JButton jButton2; // wczytaj
    private JButton jButton3; // +
    private JButton jButton4; // -
    private JButton jButton5; // Zakoncz
    private JSeparator jSeparator1; 
    private JScrollPane jScrollPane3; // panel na ktorym znajduje sie tabela
    private JTable jTable6; // tabela
    private DefaultTableModel dtm; // modelownie tabeli
    private DoubleLinkedList lista;
    
    private void initComponents() {
        jToolBar1 = new JToolBar();
        jButton1 = new JButton();
        jButton2 = new JButton();
        jButton3 = new JButton();
        jButton4 = new JButton();
        jButton5 = new JButton();
        jSeparator1 = new JSeparator();
        jScrollPane3 = new JScrollPane();
        jTable6 = new JTable();
        lista = new DoubleLinkedList();
        
        
        getContentPane().setLayout(null);
        
        setTitle("Listy Radix Sort");
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        setSize(550, 600);
        setLocation((screenSize.width-550)/2, (screenSize.height-600)/2);
        
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent evt) {
                exit();
            }
        });
        
        jButton1.setText("Zapisz");
        jToolBar1.add(jButton1);
        jButton1.addMouseListener(new MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
                saveToFile();
            }
        });
        
        jButton2.setText("Wczytaj");
        jToolBar1.add(jButton2);
        jButton2.addMouseListener(new MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
                loadOfFile();
            }
        });
        
        jButton3.setText("+");
        jToolBar1.add(jButton3);
        jButton3.addMouseListener(new MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
                addEmptyRow();
            }
        });
         
        jButton4.setText("-");
        jToolBar1.add(jButton4);
        jButton4.addMouseListener(new MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
                removeRow();
            }
        });
        
        jButton5.setText("Zakoncz");
        jToolBar1.add(jButton5);
        jButton5.addMouseListener(new MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
                exit();
            }
        });
        
        getContentPane().add(jToolBar1);
        jToolBar1.setBounds(0, 0, 220, 30);
        
        getContentPane().add(jSeparator1);
        jSeparator1.setBounds(40, 40, 460, 10);
        
        
        //wychwytujemy na jakiej kolumnie kliknelismy
        jTable6.getTableHeader().addMouseListener(new MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
                addAllToList(lista);   
                TableColumnModel columnModel = jTable6.getColumnModel();
                int viewColumn = columnModel.getColumnIndexAtX(e.getX()); 
                int column = jTable6.convertColumnIndexToModel(viewColumn); 
                if(e.getClickCount() == 1 && column != -1) {
                    int shiftPressed = e.getModifiers()&java.awt.event.InputEvent.SHIFT_MASK; 
                    boolean ascending = (shiftPressed == 0); 
                    //wysylamy do sortowania ( jako parametr kolumna po ktorej sortujemy)  
                    addAllToTabela(lista.RadixSort(column));
                }
            }
        });
        
        //okreslamy wyglad tabeli
        dtm = new DefaultTableModel(
            new Object [][] { },
            new String [] {
                "Imie", "Nazwisko", "Pesel", "Punkty" }
            );
        
        jTable6.setModel(dtm); // ustawiamy wyglad do naszej tabeli
        
        jScrollPane3.setViewportView(jTable6); //wstawiamy tabele do scrolpanela
        
        getContentPane().add(jScrollPane3);
        jScrollPane3.setBounds(40, 65, 460, 430);
    }
    
    private void saveToFile() //zapisanie tabeli najpierw do lisy a pozniej do pliku
    {
        addAllToList(lista);
        File outputFile = null;
        FileWriter out = null;
        BufferedWriter bos = null;
        
        String file = JOptionPane.showInputDialog("Podaj nazwe pliku do zapisu");
        boolean a = true;
        int n = JOptionPane.YES_OPTION;
        try{
            outputFile = new File(file); 
            if(outputFile.isFile()) {
                n = JOptionPane.showConfirmDialog(
                            null, "Plik istnieje. Nadpisac go?",
                            "UWAGA",
                            JOptionPane.YES_NO_OPTION);
                 if(n == JOptionPane.YES_OPTION) {
                    a = outputFile.delete();   
                 }
            }
            if( n == JOptionPane.YES_OPTION){
                out = new FileWriter(file, false);
                bos = new BufferedWriter(out);
                for(int i = 1; i <= lista.size(); i++){ 
                    bos.write(lista.retrieve(i).getFirstName() + " " +
                              lista.retrieve(i).getLastName() + " " +
                              lista.retrieve(i).getPesel() + " " +
                              lista.retrieve(i).getResults()
                    );
                    bos.flush();
                    bos.newLine();
                }
                bos.flush();
                bos.close();
                out.close();
            }
            
        } catch (Exception e) { JOptionPane.showMessageDialog(null, "Problemy z zapisem"); }   
    }
    
    private void loadOfFile()
    {
        File inputFile = null;
        FileReader in = null;
        BufferedReader rb = null;
        lista = new DoubleLinkedList();
        
        String file = JOptionPane.showInputDialog("Podaj nazwe pliku do odczytu");
        
        try{
            inputFile = new File(file);
            in = new FileReader(inputFile);
            rb = new BufferedReader(in);
        } catch (Exception e) {  JOptionPane.showMessageDialog(null, "Nie moge znalezc pliku"); }
	  
        String line = ""; 
        StringTokenizer st = null;
        try{  
                
            while (rb.ready()){
                line = rb.readLine();
                st = new StringTokenizer(line);
                
                lista.inject(st.nextToken(), st.nextToken(), 
                             st.nextToken(), st.nextToken());     
            }
        }catch (Exception e) {  
            JOptionPane.showMessageDialog(null, "Problemy z odczytem");
            try{
                in.close();
            }catch(Exception evt) {}
        };
        addAllToTabela(lista);
    }
    
    private void addEmptyRow()
    {
        dtm.addRow(new String[] {"","","",""} );
    }
    
    private void removeRow()
    {
        if(dtm.getRowCount() > 0){
            lista = new DoubleLinkedList();
            if(jTable6.getSelectedRowCount() != 0){
                for(int i = jTable6.getSelectedRowCount() -1 ; i >= 0; i--)
                    dtm.removeRow(jTable6.getSelectedRows()[i]);
            }
            addAllToList(lista);  
        }
    }
    
    private void addAllToList(DoubleLinkedList li)
    {
        li = new DoubleLinkedList();
        for(int i = 0; i < dtm.getRowCount(); i++) {
            li.inject((String)dtm.getValueAt(i,0), (String)dtm.getValueAt(i,1), 
                         (String)dtm.getValueAt(i,2), (String)dtm.getValueAt(i,3));
        }
        
        lista = li;
    }
    
    private void addAllToTabela(DoubleLinkedList li)
    {       
        if(dtm.getRowCount() > 0){
            for(int i = dtm.getRowCount()-1; i >= 0; i--)
                dtm.removeRow(i);
        }
        Node e = null;
        for(int i = 1; i <= li.size(); i++){
            e = li.retrieve(i);
            dtm.addRow(new String[] { e.getFirstName(), e.getLastName(), e.getPesel(), e.getResults() } ); 
        }
    }
    
    private void exit() {
        System.exit(0);
    }

    public static void main(String args[]) {
 
        new Form().show();
    }
}